/**
 * UserPreferencesChange.java
 * Creation Date - Sep 1, 2009
 * 2009 (c) Sirahu Technologies. All Rights Reserved.
 */
package com.sirahu.apptivo.view.common.backing;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.TimeZone;
import javax.faces.model.SelectItem;
import com.sirahu.apptivo.view.modal.backing.ChangePasswordModal;
import com.sirahu.apptivo.view.modal.backing.ChangeTimeZoneModal;
import com.sirahu.apptivo.view.modal.backing.TwitterAccountModal;
import com.sirahu.apptivo.view.modal.backing.FromEmailAddressModal;
import com.sirahu.apptivo.view.modal.backing.ManageCreditCardsModal;
import com.sirahu.apptivo.common.logging.MessageLogger;
import com.sirahu.apptivo.model.entities.CrmServiceAuthenticationDetail;
import com.sirahu.apptivo.model.entities.HrEmpServiceAuthDetail;
import com.sirahu.apptivo.model.entity.AppComCountry;
import com.sirahu.apptivo.model.entity.AppComCountryTimeZone;
import com.sirahu.apptivo.model.entity.AppComTimeZone;
import com.sirahu.apptivo.model.entity.AppComUser;
import com.sirahu.apptivo.model.framework.util.AppConstants;
import com.sirahu.apptivo.view.config.backing.AlertConfig;
import com.sirahu.apptivo.view.framework.backing.ModelPanelSessionStore;
import com.sirahu.apptivo.view.framework.backing.PageController;
import com.sirahu.apptivo.view.framework.util.FacesUtils;
import com.sirahu.apptivo.view.procurement.backing.ClientCreditCardsController;
import com.sirahu.apptivo.model.resources.CommonValidators;
import com.sirahu.apptivo.model.resources.ExpressionValidators;

/**
 * @author jethiraj
 * @version 1.0 Initial Version
 */
public class UserPreferencesChange extends PageController
{
	

	// Theme
	private ArrayList<SelectItem> themesList;
	private String theme;
	private String themeId;
	private HashMap<String, String> themes = null;

	

	// Google Apps
	private HrEmpServiceAuthDetail empServiceAuth = new HrEmpServiceAuthDetail();
	private String confirmPassword;
	private boolean googleAppsEnableFlag;
	
	private static final MessageLogger logger = MessageLogger.getLogger(ManageCreditCardsModal.class);
	

	@Override
	public void initPage(Object o)
	{
		// Themes
		themes = new HashMap<String, String>();
		themes.put("apptivodefault", "Apptivo");
		themes.put("blueSky", "Blue Sky");
		themes.put("classic", "Classic");
		themes.put("deepMarine", "Deep Marine");
		themes.put("japanCherry", "Japan Cherry");
		themes.put("plain", "Plain");
		themes.put("ruby", "Ruby");
		themes.put("wine", "Wine");

		theme = "Apptivo";
		themeId = "Apptivo";
		empServiceAuth = new HrEmpServiceAuthDetail();
	

		String[] themeNames = new String[themes.size()];

		int i = 0;

		for (Iterator<String> iter = themes.keySet().iterator(); iter.hasNext();)
		{
			themeNames[i++] = iter.next();
		}

		Arrays.sort(themeNames);

		themesList = new ArrayList<SelectItem>();

		for (i = 0; i < themeNames.length; i++)
		{
			SelectItem selectItem = new SelectItem(themeNames[i], themes.get(themeNames[i]));

			themesList.add(selectItem);
		}

		

		// get com user by user id
//		ComUser comUser = getUserEJB().getComUserByUserId(userConfiguration.getUserId(), userConfiguration.getFirmId());
		AppComUser comUser = getAppBaseEJB().getById(firmId, AppComUser.class, userConfiguration.getUserId());

		
		
		
	
		
		getGoogleAppsData();
		
		
	}

	/**
	 * Save   From Email Address
	 */
	
	
	/*anudeep*/
	public void changePasswordModalDisplay()
	{
		ChangePasswordModal changePassworModal = FacesUtils.getManagedBean(ChangePasswordModal.class,"backing_changePasswordModal");
		
		//System.out.println("in user preferences going to cahngepassword modal init page");
		
		logger.info("in user preferences going to cahngepassword modal init page");
		
		ModelPanelSessionStore modelPanelBean = FacesUtils.getManagedBean(ModelPanelSessionStore.class, "modelpanelbean");
		modelPanelBean.setModelPanelReturnAction("backing_userPreferencesChange", "changePasswordLovReturnAction");
		changePassworModal.setRendered(true);
		changePassworModal.initPage();
	}
	public void changePasswordLovReturnAction()
	{
		//nothing to do
	}
	
	public void changeTimeZoneModalDisplay()
	{
		
		ChangeTimeZoneModal changeTimeZoneModal = FacesUtils.getManagedBean(ChangeTimeZoneModal.class, "backing_changeTimeZoneModal");
		
		logger.info("in user preferences going to changepassword modal init page");
		ModelPanelSessionStore modelPanelBean = FacesUtils.getManagedBean(ModelPanelSessionStore.class, "modelpanelbean");
		modelPanelBean.setModelPanelReturnAction("backing_userPreferencesChange", "changeTimeZoneLovReturnAction");
		
		changeTimeZoneModal.initPage(null);
	}
	
	public void changeTimeZoneLovReturnAction()
	{
		
		// nothing to do
	}
	
	
	public void twitterAccountModalDisplay()
	{
		//System.out.println("in user preferences going to twitter account modal init page:");
		logger.info("in user preferences going to twitter account modal init page:");
		
		TwitterAccountModal twitterAccountModal = FacesUtils.getManagedBean (TwitterAccountModal.class,"backing_twitterAccountModal");
		ModelPanelSessionStore modelPanelBean = FacesUtils.getManagedBean(ModelPanelSessionStore.class, "modelpanelbean");
		modelPanelBean.setModelPanelReturnAction("backing_userPreferencesChange", "twitterAccountLovReturnAction");
		
		twitterAccountModal.initPage(null);
	}
	public void twitterAccountLovReturnAction()
	{
		//nothing to do
	}
	
	public  void manageCreditCardsModalDisplay()
	{
		ManageCreditCardsModal manageCreditCardsModal = FacesUtils.getManagedBean(ManageCreditCardsModal.class,"backing_manageCreditCardsModal");
		logger.info("in user preferences going to manage credit cards modal init page");
		ModelPanelSessionStore modelPanelBean = FacesUtils.getManagedBean(ModelPanelSessionStore.class, "modelpanelbean");
		modelPanelBean.setModelPanelReturnAction("backing_userPreferencesChange", "manageCreditCardsLovReturnAction");
		manageCreditCardsModal.initPage(null);
		
	}
	public void manageCreditCardsLovReturnAction()
	{
		//nothing to do
	}
	
	public void fromEmailAddressModalDisplay()
	{
		System.out.println("in user preferences going to from email address modal init page:");
		FromEmailAddressModal fromEmailAddressModal = FacesUtils.getManagedBean (FromEmailAddressModal.class,"backing_fromEmailAddressModal");
		ModelPanelSessionStore modelPanelBean = FacesUtils.getManagedBean(ModelPanelSessionStore.class, "modelpanelbean");
		modelPanelBean.setModelPanelReturnAction("backing_userPreferencesChange", "fromEmailAddressLovReturnAction");
		fromEmailAddressModal.initPage(null);
	}
	public void fromEmailAddressLovReturnAction()
	{
		//nothing to do
	}
	
	/*anudeep*/
	public void getGoogleAppsData()
	{
		AppComUser comUser = getAppBaseEJB().getById(firmId, AppComUser.class, userConfiguration.getUserId());
		CrmServiceAuthenticationDetail serviceAuth = getCrmServiceAuthenticationEJB().fetchAuthUser(firmId);
		empServiceAuth = getEmployeeEJB().findEmpServiceAuthDetails(comUser.getObjectRefId(), firmId);

		if (serviceAuth == null)
		{
			googleAppsEnableFlag = false;
		}
		else
		{
			googleAppsEnableFlag = true;
			if (empServiceAuth == null)
			{
				googleAppsEnableFlag = false;
			}
		}

	}
	
	


	

	

	public boolean save_validator()
	{
		boolean valid = true;
		if ("".equalsIgnoreCase(empServiceAuth.getUserPasswd()))
		{
			FacesUtils.addMessage(FacesUtils.SEVERITY_ERROR, "60042");
			valid = false;

		}
		if ("".equalsIgnoreCase(confirmPassword))
		{
			FacesUtils.addMessage(FacesUtils.SEVERITY_ERROR, "60044");
			valid = false;
		}

		if (!"".equalsIgnoreCase(confirmPassword) && !"".equalsIgnoreCase(empServiceAuth.getUserPasswd()))
		{
			if (!confirmPassword.equalsIgnoreCase(empServiceAuth.getUserPasswd()))
			{
				FacesUtils.addMessage(FacesUtils.SEVERITY_ERROR, "60046");
				valid = false;
			}
		}
		return valid;

	}

	



	public void save_googleAppInfo()
	{
		boolean valid = save_validator();
		if (valid)
		{
			boolean hrAuthDetail = getUserEJB().updateEmployeeGooglePassword(firmId, empServiceAuth);
			if (hrAuthDetail)
			{
				FacesUtils.addMessage(FacesUtils.SEVERITY_INFO, "98223");
				initPage(null);
			}
			else
			{
				FacesUtils.addMessage(FacesUtils.SEVERITY_ERROR, "98224");
				initPage(null);
			}
		}

	}

	public String theme_change_action()
	{
		Theme themeBean = FacesUtils.getManagedBean(Theme.class, "backing_theme");

		if (themeId != null && !themeId.trim().equals(""))
		{
			themeBean.setCurrentTheme(themeId);

			FacesUtils.addMessage(FacesUtils.SEVERITY_INFO, "00101");
		}
		else
		{
			FacesUtils.addMessage(FacesUtils.SEVERITY_ERROR, "00102");
		}

		return "userPreferences";
	}

	/**
	 * Change password
	 * 
	 * @return
	 */
//	public String changePassword()
//	{
//		String returnTo = null;
//
//		Long firmId = null;
//		Long userId = null;
//
//		UserConfiguration userConfiguration = FacesUtils.getManagedBean(UserConfiguration.class, "userConfiguration");
//
//		firmId = userConfiguration.getFirmId();
//		userId = userConfiguration.getUserId();
//
//		if ("".equals(this.getNewPsswd()) || this.getNewPsswd() == null || "".equals(this.getConfirmPsswd()) || this.getConfirmPsswd() == null || "".equals(this.getOldPsswd()) || this.getOldPsswd() == null)
//		{
//			FacesUtils.addMessage(FacesUtils.SEVERITY_ERROR, "8106");
//			this.clearPsswds();
//		}
//		else if (this.getNewPsswd().equals(this.getConfirmPsswd()))
//		{
//			MethodResult result = EJBFactory.getUserEJB().changePassword(this.getNewPsswd(), this.getOldPsswd(), userConfiguration.getUserEmailId(), 0L);
//
//			if (result.getStatus() == true)
//			{
//				FacesUtils.addMessage(FacesUtils.SEVERITY_INFO, result.getErrCode());
//
//				Home home = FacesUtils.getManagedBean(Home.class, "backing_home");
//				home.initPage(null);
//				returnTo = "home";
//			}
//			else
//			{
//				FacesUtils.addMessage(FacesUtils.SEVERITY_ERROR, result.getErrCode());
//			}
//		}
//		else
//		{
//			// newpsswd doesnt match with confirm passwd
//			FacesUtils.addMessage(FacesUtils.SEVERITY_ERROR, "8105");
//			this.clearPsswds();
//		}
//
//		return returnTo;
//	}
//
//	public String changePasswordAndDisplaySamePage()
//	{
//		UserConfiguration userConfiguration = FacesUtils.getManagedBean(UserConfiguration.class, "userConfiguration");
//
//		Long firmId = userConfiguration.getFirmId();
//
//		if (oldPsswd != null)
//		{
//			oldPsswd = oldPsswd.trim();
//		}
//
//		String returnTo = null;
//
//		if ("".equals(this.getNewPsswd()) || this.getNewPsswd() == null || "".equals(this.getConfirmPsswd()) || this.getConfirmPsswd() == null || "".equals(this.getOldPsswd()) || this.getOldPsswd() == null)
//		{
//			FacesUtils.addMessage(FacesUtils.SEVERITY_ERROR, "8106");
//			this.clearPsswds();
//		}
//		else if (this.getNewPsswd().equals(this.getConfirmPsswd()))
//		{
//			MethodResult result = EJBFactory.getUserEJB().changePassword(this.getNewPsswd(), this.getOldPsswd(), userConfiguration.getUserEmailId(), 0L);
//
//			if (result.getStatus())
//			{
//				FacesUtils.addMessage(FacesUtils.SEVERITY_INFO, result.getErrCode());
//			}
//			else
//			{
//				FacesUtils.addMessage(FacesUtils.SEVERITY_ERROR, result.getErrCode());
//			}
//		}
//		else
//		{
//			// newpsswd doesnt match with confirm passwd
//			FacesUtils.addMessage(FacesUtils.SEVERITY_ERROR, "8105");
//			this.clearPsswds();
//		}
//
//		return returnTo;
//	}


	
	

	

	

	

	
	

	/**
	 * @return the themesList
	 */
	public ArrayList<SelectItem> getThemesList()
	{
		return themesList;
	}

	/**
	 * @param themesList
	 *            the themesList to set
	 */
	public void setThemesList(ArrayList<SelectItem> themesList)
	{
		this.themesList = themesList;
	}

	/**
	 * @return the theme
	 */
	public String getTheme()
	{
		return theme;
	}

	/**
	 * @param theme
	 *            the theme to set
	 */
	public void setTheme(String theme)
	{
		this.theme = theme;
	}

	/**
	 * @return the themeId
	 */
	public String getThemeId()
	{
		return themeId;
	}

	/**
	 * @param themeId
	 *            the themeId to set
	 */
	public void setThemeId(String themeId)
	{
		this.themeId = themeId;
	}

	

	





	/**
	 * @return the empServiceAuth
	 */
	public HrEmpServiceAuthDetail getEmpServiceAuth()
	{
		return empServiceAuth;
	}

	/**
	 * @param empServiceAuth
	 *            the empServiceAuth to set
	 */
	public void setEmpServiceAuth(HrEmpServiceAuthDetail empServiceAuth)
	{
		this.empServiceAuth = empServiceAuth;
	}

	/**
	 * @return the confirmPassword
	 */
	public String getConfirmPassword()
	{
		return confirmPassword;
	}

	/**
	 * @param confirmPassword
	 *            the confirmPassword to set
	 */
	public void setConfirmPassword(String confirmPassword)
	{
		this.confirmPassword = confirmPassword;
	}

	/**
	 * @return the googleAppsEnableFlag
	 */
	public boolean isGoogleAppsEnableFlag()
	{
		return googleAppsEnableFlag;
	}

	/**
	 * @param googleAppsEnableFlag
	 *            the googleAppsEnableFlag to set
	 */
	public void setGoogleAppsEnableFlag(boolean googleAppsEnableFlag)
	{
		this.googleAppsEnableFlag = googleAppsEnableFlag;
	}



	


	
	

}
